import { DeepstreamClient } from "@deepstream/client";
import { SubscriptionCallback } from "./validate";
import { UserData, JSONValue, JSONObject } from "./validate";
export declare class Record {
    #private;
    constructor(ds: DeepstreamClient, name: string);
    load(initObject?: UserData, overwrite?: boolean): Promise<void>;
    get whenLoaded(): Promise<void>;
    /**
     * sets initial data on the record only if the record is empty
     *
     * @param data initial data to set on the record
     */
    initData(data: UserData, overwrite?: boolean): Promise<void>;
    setData(data: UserData): void;
    watchShared(callback: SubscriptionCallback, triggerNow?: boolean): void;
    watchShared(path: string, callback: SubscriptionCallback, triggerNow?: boolean): void;
    get shared(): JSONObject;
    get name(): string;
    delete(): Promise<unknown>;
    _set(path: string, value: JSONValue): Promise<void>;
    _get(key?: string): JSONValue;
    static recordForShared(watchedShared: JSONObject): Record | undefined;
}
