import { SubscriptionCallback } from "./validate";
import { UserData, JSONObject } from "./validate";
import { Record } from "./Record";
export declare class Room {
    #private;
    constructor(host: string, appName: string, roomName: string);
    _isConnected(): boolean;
    get whenConnected(): Promise<void>;
    disconnect(): void;
    info(): {
        appName: string;
        roomName: string;
        guestNames: string[];
        guestName: string;
        isConnected: boolean;
        isHost: boolean;
    };
    getRecord(name: string): Record;
    subscribe(event: string, cb: SubscriptionCallback): void;
    unsubscribe(event: string, cb?: SubscriptionCallback): void;
    emit(event: string, data?: UserData): void;
    get hostName(): string | undefined;
    get _guestNames(): string[];
    get myGuestRecord(): Record;
    get guestShareds(): JSONObject[];
    isHost(): boolean;
}
